#!/usr/bin/perl

## POWERSEEK PLUGIN ########################
#
# TITLE: Specialized Search Creator
# DIZ: Enables you to create specialized searches to search specified fields.
# GRAPHIC: ic_search2.gif
# VERSION: 1.0
# 
###########################################
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################
print "Content-type: text/html\n\n";
if ($q->param('fct') eq "start2") { &start2; }
if ($q->param('fct') eq "") { &start; }
if ($q->param('fct') eq "get_search_form") { &get_search_form; }
if ($q->param('fct') eq "adv_start") { &adv_start; }
if ($q->param('fct') eq "add_new_advanced") { &add_new_advanced; }
if ($q->param('fct') eq "create_adv") { &create_adv; }
if ($q->param('fct') eq "delete_search") { &delete_search; }
if ($q->param('fct') eq "get_search_code") { &get_search_code; }
if ($q->param('fct') eq "edit_search") { &edit_search; }
if ($q->param('fct') eq "save_adv_search") { &save_adv_search; }
if ($q->param('fct') eq "delete_search2") { &delete_search2; }
if ($q->param('fct') eq "cat_search_start") { &cat_search_start; }
if ($q->param('fct') eq "ctemplates") { &ctemplates; }
if ($q->param('fct') eq "create_custom_tset") { &create_custom_tset; }
if ($q->param('fct') eq "create_custom_tset_final") { &create_custom_tset_final; }
if ($q->param('fct') eq "edit_cust_tmpl") { &edit_cust_tmpl; }
if ($q->param('fct') eq "del_cust_tmpl") { &del_cust_tmpl; }
if ($q->param('fct') eq "save_custom_tset") { &save_custom_tset; }
if ($q->param('fct') eq "assign_template") { &assign_template; }
if ($q->param('fct') eq "assign_template_final") { &assign_template_final; }
if ($q->param('fct') eq "choose_search_create") { &choose_search_create; }
if ($q->param('fct') eq "new_search_setup") { &new_search_setup; }
if ($q->param('fct') eq "create_sql_final") { &create_sql_final; }
if ($q->param('fct') eq "edit_searchsql") { &edit_searchsql; }
if ($q->param('fct') eq "save_sql_search") { &save_sql_search; }
if ($q->param('fct') eq "get_search_codesql") { &get_search_codesql; }

####################################################################################

sub get_search_codesql
{
$id = $q->param('id');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sth = $dbh->prepare("SELECT sql_qq, searchname FROM advsearcht WHERE searchid = '$id'");
$sth->execute; 
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

while ( @row = $sth->fetchrow() )
	{
	$sql_q = $row[0];
	$searchname = $row[1];
	}

$sth->finish;
$dbh->disconnect;

while ($endex eq "")
	{
	if ($sql_q =~ m/!!/g)
		{
		$r = pos($sql_q);
		push (@coordin, $r);
		}
		else
		{
		$endex = "true";
		}
	}


$posl = 1;
foreach $item (@coordin)
	{
	if ($posl == 1) { $start = $item; $posl++; }
	elsif ($posl == 2) 
			{
			$endpos = $item;
			push (@boxitems, substr($sql_q, $start, $item - $start  - 2));
			$posl = 1;
			}
		
	}


foreach $item (@boxitems)
	{
	$foundmatch = "false";
		foreach $nitem (@cleanbnames)
			{
			if ($item eq $nitem) {$foundmatch = "true";}
			}
	
		if ($foundmatch eq "false")
			{
			push (@cleanbnames, $item);
			}
	}


foreach $item (@cleanbnames)
	{
	$html_code_box = $html_code_box . qq[$item : <input type="text" name="$item" size="20">\n];
	}

chop($html_code_box);

$complete_code = $complete_code . qq[
<form method="POST" action="$script_url/spcsearch.cgi">
$html_code_box
<input type="hidden" name="id" value="$id-s">
<input type="submit" value="Search" name="B1">
</form>
];


$testsearch_code = $testsearch_code . qq[
<form method="POST" action="$script_url/spcsearch.cgi" target="_blank">
$html_code_box
<input type="hidden" name="id" value="$id-s">
<input type="submit" value="Search" name="B1">
</form>
];




$hbox = acs::get_heading_box("$web_url/ic_searchc4.gif", "Obtain Search Box HTML Code for Search", qq[
<b>Saerch Box HTML Code:</b>
<form method="POST" action="$admin_url/p_specsearch.cgi">
  <p><textarea rows="12" name="S1" cols="61" style="width:100%">$complete_code</textarea></p>
</form>
Feel free to customize the HTML code.<BR>
<BR>
<b><a href="$admin_url/p_specsearch.cgi?fct=adv_start">Click Here to Continue</a></b>
]);

print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox

<table border="0" cellpadding="6" cellspacing="1" width="100%"
style="border: 1px solid rgb(218,218,218)">
  <tr>
    <td width="60%" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Test
    Search:</strong></td>
  </tr>
  <tr>
    <td width="60%" valign="top" class="normaltext">$testsearch_code</td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>

</body>
</html>
];





}



sub save_sql_search
{

$id = $q->param('id');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sqlq = $q->param('sqlq');
$sqlq = $dbh->quote($sqlq); 

$sth = $dbh->prepare("UPDATE advsearcht SET sql_qq = $sqlq WHERE searchid = '$id'");
$sth->execute; 
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

$sth->finish;
$dbh->disconnect;


$hbox = acs::get_heading_box("$web_url/ic_searchc4.gif", "Search Saved", qq[
<b><a href="$admin_url/p_specsearch.cgi?fct=adv_start">Click Here to Continue</a></b>
]);

print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

}




sub edit_searchsql
{

$id = $q->param('id');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sth = $dbh->prepare("SELECT sql_qq, searchname FROM advsearcht WHERE searchid = '$id'");
$sth->execute; 
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

while ( @row = $sth->fetchrow() )
	{
	$sql_q = $row[0];
	$searchname = $row[1];
	}

$sth->finish;
$dbh->disconnect;



$hbox = acs::get_heading_box("$web_url/ic_searchc4.gif", "Edit SQL Based Advanced Search", qq[
Saerch Name: <b>$searchname</b>
<BR><BR>
<b><a href="$admin_url/p_specsearch.cgi" onClick="history.go(-1); return false;">Go Back</a></b>
]);

$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

	### GET EXTRA FIELD DETAILS
	foreach $k_item (@akeys)
		{
		($keyname, $visible, $size, $searched, $description1, $na, $imgk, $numberfield, $req, $allow_html, $carriage_pagebreak) = split (/\t/, $k_item);
		$knvalue = $keyname . "_cust";
  		$key_details = $key_details . 
  		qq[ <tr>
    <td width="1%" height="21" class="normaltext"><font color="#8080FF"><strong>$knvalue</strong></font></td>
    <td width="99%" height="21" class="normaltext">This is an extra field</td>
  </tr> ];
		}



print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox

<form method="POST" action="$admin_url/p_specsearch.cgi">
  <input type="hidden" name="fct" value="save_sql_search"><input type="hidden" name="id"
  value="$id"><table border="0" cellpadding="6" cellspacing="1" width="100%"
  style="border: 1px solid rgb(218,218,218)">
    <tr>
      <td width="80%" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>SQL
      Query:</strong></td>
    </tr>
    <tr>
      <td class="normaltext"><b>SELECT * FROM links WHERE</b><br>
      <textarea rows="8" name="sqlq" cols="59" style="width:100%">$sql_q</textarea></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
  <p><input type="submit" value="Save Search" name="B1"><br>
  <br>
  </p>
  <table border="0" cellpadding="6" cellspacing="1" width="100%"
  style="border: 1px solid rgb(218,218,218)">
    <tr>
      <td width="40%" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Fields
      Available in 'links' Table:</strong></td>
      <td width="40%" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Instructions
      &amp; Example:</strong></td>
    </tr>
    <tr>
      <td width="40%" class="normaltext" valign="top"><table border="0" cellpadding="6"
      cellspacing="1" width="100%">
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>lnkid</strong></td>
          <td width="99%" height="21" class="normaltext">Link ID</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>cid</strong></td>
          <td width="99%" height="21" class="normaltext">Category ID (Linked to 'dirs' table that
          stores categories)</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>title</strong></td>
          <td width="99%" height="21" class="normaltext">Link Title</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>description</strong></td>
          <td width="99%" height="21" class="normaltext">Link Description</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>keywords</strong></td>
          <td width="99%" height="21" class="normaltext">Link Keywords</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>url</strong></td>
          <td width="99%" height="21" class="normaltext">Link URL</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>name</strong></td>
          <td width="99%" height="21" class="normaltext">Link Ower Name</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>email</strong></td>
          <td width="99%" height="21" class="normaltext">Link Owner Contact Email Address</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>rating</strong></td>
          <td width="99%" height="21" class="normaltext">Link Rating</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>votes</strong></td>
          <td width="99%" height="21" class="normaltext">Number of Votes Link Received</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>hits</strong></td>
          <td width="99%" height="21" class="normaltext">Number of Hits</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>userid</strong></td>
          <td width="99%" height="21" class="normaltext">Urser ID (Linked to 'lnkusers' table which
          holds user accounts)</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>rev_no</strong></td>
          <td width="99%" height="21" class="normaltext">Number of reviews link received</td>
        </tr>
$key_details
      </table>
      </td>
      <td width="40%" class="normaltext" valign="top"
      style="border-left: 1px solid rgb(218,218,218)"><ul>
        <li>You can use any valid SQL in the SQL Query box above.<br>
          &nbsp;&nbsp; </li>
        <li>The search to be created requires a keyword box or keyword boxes were the visitor
          supplies keywords to search for. To specify in the SQL Query that an input box for keyword
          input (from visitors) needs to be used specify a name for the input box with exclamation
          marks on both sides of the name.<br>
          &nbsp; <br>
          <strong>For example:<br>
          &nbsp; <br>
          SELECT * FROM LINKS <br>
          WHERE (title LIKE '%!!keywords!!%') OR (description LIKE&nbsp; '%!!keywords!!%')<br>
          &nbsp; <br>
          </strong>PowerSeek will take the above SQL query above and provide you with HTML code
          looking like this:<br>
          <br>
          &lt;form method=&quot;POST&quot; action=&quot;$script_url/spcsearch.cgi&quot;&gt;<br>
          &lt;input type=&quot;text&quot; name=&quot;<strong>keywords</strong>&quot;
          size=&quot;20&quot;&gt;<br>
          &lt;input type=&quot;submit&quot; value=&quot;Search&quot; name=&quot;B1&quot;&gt;<br>
          &lt;input type=&quot;hidden&quot; name=&quot;id&quot; value=&quot;some id&quot;&gt;<br>
          &lt;/form&gt;<br>
          &nbsp;&nbsp; <br>
          The HTML code of the search box above will create a 'keywords' input or fill-in box where
          keywords can be typed that will be matched against the 'title' and 'description' fields of
          the links table inside the database. This is because <strong>!!keywords!!</strong> has
          been specified as a match against the 'title' and 'description' fields in the SQL query.<br>
          &nbsp; </li>
        <li><strong>Another Example:<br>
          &nbsp;&nbsp; <br>
          </strong>If the query looks like this:<br>
          &nbsp; <br>
          <strong>SELECT * FROM LINKS <br>
          WHERE (title LIKE '%!!title_keywords!!%') AND (description = %'!!desc_keywords!!%')<br>
          <br>
          </strong>The query means that 2 keyword inputs (fill-in-boxes) that visitors will fill in
          needs to match link titles and descriptions. In other words there needs to be a match in
          the 'title' field and there needs to be a match in the 'description' field in the keyword
          boxes supplied.<br>
          &nbsp; <br>
          The Search Box HTML code PowerSeek will provide for this query will look like this:<br>
          &nbsp; <br>
          &lt;form method=&quot;POST&quot; action=&quot;$script_url/spcsearch.cgi&quot;&gt;<br>
          title_keywords &lt;input type=&quot;text&quot; name=&quot;<strong>title_keywords</strong>&quot;
          size=&quot;20&quot;&gt;&lt;BR&gt;<br>
          desc_keywords &lt;input type=&quot;text&quot; name=&quot;<strong>desc_keywords</strong>&quot;
          size=&quot;20&quot;&gt;&lt;BR&gt;<br>
          &lt;input type=&quot;submit&quot; value=&quot;Search&quot; name=&quot;B1&quot;&gt;<br>
          &lt;input type=&quot;hidden&quot; name=&quot;id&quot; value=&quot;some id&quot;&gt;<br>
          &lt;/form&gt;</li>
      </ul>
      </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>



</body>
</html>
];


}


sub create_sql_final
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sqlq = $q->param('sqlq');
$sqlq = $dbh->quote($sqlq); 

$searchname = $q->param('searchname');
$searchname = $dbh->quote($searchname); 

$sth = $dbh->prepare("INSERT INTO advsearcht SET searchname = $searchname, sql_qq = $sqlq");
$sth->execute; 
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

$sth->finish;
$dbh->disconnect;


$hbox = acs::get_heading_box("$web_url/ic_searchc4.gif", "SQL Based Search Created", qq[
<b><a href="$admin_url/p_specsearch.cgi?fct=adv_start">Click Here to Continue</a></b>
]);


print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];


}



sub new_search_setup
{

$searchname = $q->param('searchname');

if ($searchname eq "")
	{
	acs::problem_popup("You have to specify a name for the saerch you are about to create.");
	}

$stype = $q->param('stype');

if ($stype eq "Automated")
	{
	&add_new_advanced();
	}
	else
	{
	&sql_create_scr;
	}

}





sub sql_create_scr
{

$hbox = acs::get_heading_box("$web_url/ic_searchc4.gif", "Create an Advanced Search with SQL", qq[
<b><a href="$admin_url/p_specsearch.cgi" onClick="history.go(-1); return false;">Go Back</a></b>
]);


$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

	### GET EXTRA FIELD DETAILS
	foreach $k_item (@akeys)
		{
		($keyname, $visible, $size, $searched, $description1, $na, $imgk, $numberfield, $req, $allow_html, $carriage_pagebreak) = split (/\t/, $k_item);
		$knvalue = $keyname . "_cust";
  		$key_details = $key_details . 
  		qq[ <tr>
    <td width="1%" height="21" class="normaltext"><font color="#8080FF"><strong>$knvalue</strong></font></td>
    <td width="99%" height="21" class="normaltext">This is an extra field</td>
  </tr> ];
		}


print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox


<form method="POST" action="$admin_url/p_specsearch.cgi">
  <input type="hidden" name="fct" value="create_sql_final"><input type="hidden"
  name="searchname" value="$searchname"><table border="0" cellpadding="6" cellspacing="1"
  width="100%" style="border: 1px solid rgb(218,218,218)">
    <tr>
      <td width="80%" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>SQL
      Query:</strong></td>
    </tr>
    <tr>
      <td class="normaltext"><b>SELECT * FROM links WHERE</b><br>
      <textarea rows="8" name="sqlq" cols="59" style="width:100%"></textarea></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
  <p><input type="submit" value="Create Search" name="B1"><br>
  <br>
  </p>
  <table border="0" cellpadding="6" cellspacing="1" width="100%"
  style="border: 1px solid rgb(218,218,218)">
    <tr>
      <td width="40%" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Fields
      Available in 'links' Table:</strong></td>
      <td width="40%" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Instructions
      &amp; Example:</strong></td>
    </tr>
    <tr>
      <td width="40%" class="normaltext" valign="top"><table border="0" cellpadding="6"
      cellspacing="1" width="100%">
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>lnkid</strong></td>
          <td width="99%" height="21" class="normaltext">Link ID</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>cid</strong></td>
          <td width="99%" height="21" class="normaltext">Category ID (Linked to 'dirs' table that
          stores categories)</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>title</strong></td>
          <td width="99%" height="21" class="normaltext">Link Title</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>description</strong></td>
          <td width="99%" height="21" class="normaltext">Link Description</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>keywords</strong></td>
          <td width="99%" height="21" class="normaltext">Link Keywords</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>url</strong></td>
          <td width="99%" height="21" class="normaltext">Link URL</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>name</strong></td>
          <td width="99%" height="21" class="normaltext">Link Ower Name</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>email</strong></td>
          <td width="99%" height="21" class="normaltext">Link Owner Contact Email Address</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>rating</strong></td>
          <td width="99%" height="21" class="normaltext">Link Rating</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>votes</strong></td>
          <td width="99%" height="21" class="normaltext">Number of Votes Link Received</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>hits</strong></td>
          <td width="99%" height="21" class="normaltext">Number of Hits</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>userid</strong></td>
          <td width="99%" height="21" class="normaltext">Urser ID (Linked to 'lnkusers' table which
          holds user accounts)</td>
        </tr>
        <tr>
          <td width="1%" height="21" class="normaltext"><strong>rev_no</strong></td>
          <td width="99%" height="21" class="normaltext">Number of reviews link received</td>
        </tr>
$key_details
      </table>
      </td>
      <td width="40%" class="normaltext" valign="top"
      style="border-left: 1px solid rgb(218,218,218)"><ul>
        <li>You can use any valid SQL in the SQL Query box above.<br>
          &nbsp;&nbsp; </li>
        <li>The search to be created requires a keyword box or keyword boxes were the visitor
          supplies keywords to search for. To specify in the SQL Query that an input box for keyword
          input (from visitors) needs to be used specify a name for the input box with exclamation
          marks on both sides of the name.<br>
          &nbsp; <br>
          <strong>For example:<br>
          &nbsp; <br>
          SELECT * FROM LINKS <br>
          WHERE (title LIKE '%!!keywords!!%') OR (description LIKE&nbsp; '%!!keywords!!%')<br>
          &nbsp; <br>
          </strong>PowerSeek will take the above SQL query above and provide you with HTML code
          looking like this:<br>
          <br>
          &lt;form method=&quot;POST&quot; action=&quot;$script_url/spcsearch.cgi&quot;&gt;<br>
          &lt;input type=&quot;text&quot; name=&quot;<strong>keywords</strong>&quot;
          size=&quot;20&quot;&gt;<br>
          &lt;input type=&quot;submit&quot; value=&quot;Search&quot; name=&quot;B1&quot;&gt;<br>
          &lt;input type=&quot;hidden&quot; name=&quot;id&quot; value=&quot;some id&quot;&gt;<br>
          &lt;/form&gt;<br>
          &nbsp;&nbsp; <br>
          The HTML code of the search box above will create a 'keywords' input or fill-in box where
          keywords can be typed that will be matched against the 'title' and 'description' fields of
          the links table inside the database. This is because <strong>!!keywords!!</strong> has
          been specified as a match against the 'title' and 'description' fields in the SQL query.<br>
          &nbsp; </li>
        <li><strong>Another Example:<br>
          &nbsp;&nbsp; <br>
          </strong>If the query looks like this:<br>
          &nbsp; <br>
          <strong>SELECT * FROM LINKS <br>
          WHERE (title LIKE '%!!title_keywords!!%') AND (description = %'!!desc_keywords!!%')<br>
          <br>
          </strong>The query means that 2 keyword inputs (fill-in-boxes) that visitors will fill in
          needs to match link titles and descriptions. In other words there needs to be a match in
          the 'title' field and there needs to be a match in the 'description' field in the keyword
          boxes supplied.<br>
          &nbsp; <br>
          The Search Box HTML code PowerSeek will provide for this query will look like this:<br>
          &nbsp; <br>
          &lt;form method=&quot;POST&quot; action=&quot;$script_url/spcsearch.cgi&quot;&gt;<br>
          title_keywords &lt;input type=&quot;text&quot; name=&quot;<strong>title_keywords</strong>&quot;
          size=&quot;20&quot;&gt;&lt;BR&gt;<br>
          desc_keywords &lt;input type=&quot;text&quot; name=&quot;<strong>desc_keywords</strong>&quot;
          size=&quot;20&quot;&gt;&lt;BR&gt;<br>
          &lt;input type=&quot;submit&quot; value=&quot;Search&quot; name=&quot;B1&quot;&gt;<br>
          &lt;input type=&quot;hidden&quot; name=&quot;id&quot; value=&quot;some id&quot;&gt;<br>
          &lt;/form&gt;</li>
      </ul>
      </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>




</body>
</html>
];

}





sub choose_search_create
{

if ($q->param('B2') ne "") { &ctemplates; exit; }

$hbox = acs::get_heading_box("$web_url/ic_searchc4.gif", "Create an Advanced Search", qq[
<b><a href="$admin_url/p_specsearch.cgi?fct=adv_start">Go Back</a></b>
]);


print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox


<form method="POST" action="$admin_url/p_specsearch.cgi">
  <input type="hidden" name="fct" value="new_search_setup"><table border="0" cellpadding="6"
  cellspacing="1" width="100%" style="border: 1px solid rgb(218,218,218)">
    <tr>
      <td width="100%" valign="top" class="normaltext" colspan="2"
      background="$web_url/bar6.gif"><strong>Specify Details Below:</strong></td>
    </tr>
    <tr>
      <td width="30%" valign="top" class="normaltext"><strong>Choose a Name For This Search:</strong></td>
      <td width="70%" class="normaltext"><input type="text" name="searchname" size="41"></td>
    </tr>
    <tr>
      <td width="30%" class="normaltext" valign="top"><strong>Search Type:</strong></td>
      <td width="70%" class="normaltext"><table border="0" cellpadding="3" cellspacing="1"
      width="100%">
        <tr class="normaltext">
          <td width="1%" valign="top"><input type="radio" value="Automated" name="stype" checked></td>
          <td width="80%"><strong>Automated - </strong>This option is easier to use than the 'SQL
          Based' option below. It provides you with automated options on setting up searches but is
          also very functional like the SQL Based search option.</td>
        </tr>
        <tr class="normaltext">
          <td width="1%" valign="top"><input type="radio" value="sql" name="stype"></td>
          <td width="80%"><strong>SQL Based - </strong>This is an advanced option where you can
          specify and SQL query to create any kind of search. Note that you will have to know basic
          SQL to use this option. The Internet has an abundance of SQL tutorials available. Many SQL
          tutorials can be found with a quick search at Google.com</td>
        </tr>
      </table>
      </td>
    </tr>
    <tr>
      <td width="30%" class="normaltext"></td>
      <td width="70%" class="normaltext"><input type="submit" value="   Next   " name="B1">
       <input type="submit" value="   Back   " name="B1" onClick="history.go(-1); return false;"></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

</body>
</html>
];


}




sub assign_template_final
{

$tid = $q->param('template_sets_available');
$searchid = $q->param('searchid');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sth = $dbh->prepare("UPDATE advsearcht SET template = '$tid' WHERE searchid = '$searchid'");
$sth->execute; 
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

$sth->finish;
$dbh->disconnect;


$hbox = acs::get_heading_box("$web_url/ic_searchc4.gif", "Template Set Assigned to Search", qq[
<a href="javascript:onClick=window.close()">Click Here to close this Window</a> or use your web browser's back button to go back.
]);




print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body onUnload="opener.location.reload(true);">
$hbox
</body>
</html>
];



}




sub assign_template
{

$searchid = $q->param('id');


#### GET CURRENT TEMPLATE IN USE

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sth = $dbh->prepare("SELECT * FROM advsearcht WHERE searchid = '$searchid'");
$sth->execute; 
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
while ( @row = $sth->fetchrow() )
	{
	$searchname = $row[1];
	$template_id_in_use = $row[125];
	}


if ($template_id_in_use eq "") { $default_selected = "selected"; }

#### GET CUSTOM TEMPLATES
$sth = $dbh->prepare("SELECT * FROM advsearchtmpl");
$sth->execute; 
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
while ( @row = $sth->fetchrow() )
	{
		if ($row[0] eq $template_id_in_use)
			{
			$select_optoins = $select_optoins . qq[<option value="$row[0]" selected>$row[1]</option>];
			}
			else
			{
			$select_optoins = $select_optoins . qq[<option value="$row[0]">$row[1]</option>];
			}
	}




$sth->finish;
$dbh->disconnect;


$hbox = acs::get_heading_box("$web_url/ic_searchc4.gif", "Assign a Custom Template Set", qq[
This section allows you to assign a Custom Template set to use for Search: <b>$searchname</b><BR><BR>
<b>Choose a Template Set to use for '$searchname' from the drop down box below: </b><BR>

<form method="POST" action="$admin_url/p_specsearch.cgi">
  <input type="hidden" name="fct" value="assign_template_final">
  <input type="hidden" name="searchid" value="$searchid"><p> 
  <select name="template_sets_available" size="1">
   <option value="" $default_selected>Default</option>
    $select_optoins
  </select> <input type="submit" value="Assign Template Set for Search" name="B1"></p>
</form>


]);


$helpb = acs::quick_help("Quick Help",qq[
<ul>
  <li class="normaltext"> Click the 'Create or Edit Specialised Saerch Template Sets' to create or edit search template sets to be used for specific searches you create in the 'Previous Window'. </li>
  <li class="normaltext">When you assign the 'Default' template set to be used then the default PowerSeek 'Search Results Templates' will be used to display search results for the specialized search called: <b>$searchname</b>.</li>
  <li class="normaltext"> Note that the 'Default PowerSeek Search Results Templates' can be edited when clicking the 'Template Manager' tab. Then click '2. Search Result Templates' </li>
</ul>
]);



print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
$helpb
</body>
</html>
];



}


sub save_custom_tset
{

$tid = $q->param('tid');

$tmpl1 = "custom-searchres_" . $tid . ".html";
open (TMPL1, "> $data_dir/$tmpl1");
	print TMPL1 $q->param('searchres');
close (TMPL1);

$tmpl2 = "custom-lsearchres_" . $tid . ".html";
open (TMPL2, "> $data_dir/$tmpl2");
	print TMPL2 $q->param('lsearchres_loc');
close (TMPL2);

$tmpl3 = "custom-lsearchresp_" . $tid . ".html";
open (TMPL3, "> $data_dir/$tmpl3");
	print TMPL3 $q->param('lsearchres_loc_prem');
close (TMPL3);

$tmpl4 = "custom-nomatch_" . $tid . ".html";
open (TMPL4, "> $data_dir/$tmpl4");
	print TMPL4 $q->param('nomatch');
close (TMPL4);


$hbox = acs::get_heading_box("$web_url/ic_searchc4.gif", "Template Set Saved", qq[
<a href="$admin_url/p_specsearch.cgi?fct=ctemplates">Click Here to Continue</a>
]);


print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

}



sub del_cust_tmpl
{

$tid = $q->param('tid');

$tmpl1 = "custom-searchres_" . $tid . ".html";
unlink ("$data_dir/$tmpl1");

$tmpl2 = "custom-lsearchres_" . $tid . ".html";
unlink ("$data_dir/$tmpl2");

$tmpl3 = "custom-lsearchresp_" . $tid . ".html";
unlink ("$data_dir/$tmpl3");

$tmpl4 = "custom-nomatch_" . $tid . ".html";
unlink ("$data_dir/$tmpl4");


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sth = $dbh->prepare("DELETE FROM advsearchtmpl WHERE tid = '$tid'");
$sth->execute; 
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

$sth->finish;
$dbh->disconnect;


$hbox = acs::get_heading_box("$web_url/ic_searchc4.gif", "Template Set Deleted", qq[
<a href="$admin_url/p_specsearch.cgi?fct=ctemplates">Click Here to Continue</a>
]);


print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];



}



sub edit_cust_tmpl
{

$tid = $q->param('tid');


$hbox = acs::get_heading_box("$web_url/ic_searchc4.gif", "Editing Specialised Search Template Set", qq[

<b><a href="$admin_url/p_specsearch.cgi?fct=adv_start">Setup/Configure Advanced Specialised Searches</a> >> 
<a href="$admin_url/p_specsearch.cgi?fct=ctemplates">Specialised Search Template Sets</a> >> Editing</b>

]);


$tmpl1 = "custom-searchres_" . $tid . ".html";
$searchres = acs::get_file_contents("$data_dir/$tmpl1");

$tmpl2 = "custom-lsearchres_" . $tid . ".html";
$lsearchres_loc = acs::get_file_contents("$data_dir/$tmpl2");

$tmpl3 = "custom-lsearchresp_" . $tid . ".html";
$lsearchres_loc_prem = acs::get_file_contents("$data_dir/$tmpl3");

$tmpl4 = "custom-nomatch_" . $tid . ".html";
$nomatch = acs::get_file_contents("$data_dir/$tmpl4");


print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<script LANGUAGE="JavaScript">
<!-- Hide

  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);

    var winl = (screen.width-ww)/2;
	 var wint = (screen.height-hh)/2;
    
    var myspecs = 'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=' + mywidth + ',height=' + myheight + ',top=' + wint + ',left=' + winl;
	var random = parseInt(Math.random()*10000)

	  var popupwin = null;
      myWindow = open (loc, popupwin + random, myspecs);
      myWindow.moveTo(100,40);
      myWindow.focus();

    }
// End Hide -->
</script>
<body>
$hbox


<form method="POST" action="$admin_url/p_specsearch.cgi">
  <input type="hidden" name="fct" value="save_custom_tset"><input type="hidden" name="tid"
  value="$tid"><table width="100%" border="0" cellpadding="6" cellspacing="1"
  bordercolor="#DDDDDD" style="border: 1px solid rgb(225,225,225)">
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext" background="$web_url/bar6.gif"><strong>Main
      Search Page</strong></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext">This is the main template acting as
      a frame around Search Results.<br>
      <img src="$web_url/lar3.gif"><a
      href="$admin_url/admin78.cgi?t=searchres&amp;fct=explain&amp;body=true"
      onClick="popup('$admin_url/admin78.cgi?t=searchres&amp;fct=explain&amp;body=true',screen.width-250,screen.height-250);return false;">
      Explanation of Variables used inside this template</a></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><textarea rows="22" name="searchres"
      cols="98" style="width:100%">$searchres</textarea></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext" background="$web_url/bar6.gif"><strong>Links
      Style</strong></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext">This template is used when
      displaying matched links after a search. <br>
      <img src="$web_url/lar3.gif"><a
      href="$admin_url/admin78.cgi?t=lsearchres_loc&amp;fct=explain&amp;body=true"
      onClick="popup('$admin_url/admin78.cgi?t=lsearchres_loc&amp;fct=explain&amp;body=true',screen.width-250,screen.height-250);return false;">Explanation
      of Variables used inside this template</a></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><textarea rows="22"
      name="lsearchres_loc" cols="98" style="width:100%">$lsearchres_loc</textarea></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext" background="$web_url/bar6.gif"><strong>Premium
      Links Style</strong></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext">This template is used when
      displaying premium link listings in search results.<br>
      <img src="$web_url/lar3.gif"><a
      href="$admin_url/admin78.cgi?t=lsearchres_loc_prem&amp;fct=explain&amp;body=true"
      onClick="popup('$admin_url/admin78.cgi?t=lsearchres_loc_prem&amp;fct=explain&amp;body=true',screen.width-250,screen.height-250);return false;">Explanation
      of Variables used inside this template</a></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><textarea rows="22"
      name="lsearchres_loc_prem" cols="98" style="width:100%">$lsearchres_loc_prem</textarea></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext" background="$web_url/bar6.gif"><strong>No
      Match</strong></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext">This template is displayed when a
      search revealed no matches. In order to use this template.<br>
      <img src="$web_url/lar3.gif"><a
      href="$admin_url/admin78.cgi?t=nomatch&amp;fct=explain&amp;body=true"
      onClick="popup('$admin_url/admin78.cgi?t=nomatch&amp;fct=explain&amp;body=true',screen.width-250,screen.height-250);return false;">Explanation
      of Variables used inside this template</a></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext" style="width:100%"><textarea
      rows="22" name="nomatch" cols="98" style="width:100%">$nomatch</textarea></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><input type="submit"
      value="   Save Template Set   " name="B1"></td>
    </tr>
  </table>
</form>

</body>
</html>
];



}


sub create_custom_tset_final
{

$tname = $q->param('tname');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$tname = $dbh->quote($tname); 

$sth = $dbh->prepare("INSERT INTO advsearchtmpl SET tmplname = $tname");
$sth->execute; 
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}


$sth = $dbh->prepare("SELECT tid FROM advsearchtmpl WHERE tid = LAST_INSERT_ID()");
$sth->execute; 
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
while ( @row = $sth->fetchrow() )
	{
	$tmpl_id = $row[0];
	}

$sth->finish;
$dbh->disconnect;

#########

$tmpl1 = "custom-searchres_" . $tmpl_id . ".html";
open (TMPL1, "> $data_dir/$tmpl1");
	print TMPL1 $q->param('searchres');
close (TMPL1);

$tmpl2 = "custom-lsearchres_" . $tmpl_id . ".html";
open (TMPL2, "> $data_dir/$tmpl2");
	print TMPL2 $q->param('lsearchres_loc');
close (TMPL2);

$tmpl3 = "custom-lsearchresp_" . $tmpl_id . ".html";
open (TMPL3, "> $data_dir/$tmpl3");
	print TMPL3 $q->param('lsearchres_loc_prem');
close (TMPL3);

$tmpl4 = "custom-nomatch_" . $tmpl_id . ".html";
open (TMPL4, "> $data_dir/$tmpl4");
	print TMPL4 $q->param('nomatch');
close (TMPL4);

############

$hbox = acs::get_heading_box("$web_url/ic_searchc4.gif", "Template Set Created", qq[
<a href="$admin_url/p_specsearch.cgi?fct=ctemplates">Click Here to Continue</a>
]);

print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

}





sub create_custom_tset
{

$tname = $q->param('tname');

if ($tname eq "")
	{
	acs::problem_popup("You have to specify a name for the template set you are about to create.");
	}

if (length($tname) > "40")
	{
	acs::problem_popup("The maximum length of the name is 40 characters. Please use less characters.");
	}


$hbox = acs::get_heading_box("$web_url/ic_searchc4.gif", "Create a Specialised Search Template Set", qq[
Note that the 'default' search templates are placed in the edit boxes below.
<BR><BR>
<b><a href="$admin_url/p_specsearch.cgi?fct=adv_start">Setup/Configure Advanced Specialised Searches</a> >> 
<a href="$admin_url/p_specsearch.cgi?fct=ctemplates">Specialised Search Template Sets</a> >> Creating a New Template Set</b>
]);


$searchres = acs::get_file_contents("$data_dir/searchres.html");
$lsearchres_loc = acs::get_file_contents("$data_dir/lsearchres_loc.html");
$lsearchres_loc_prem = acs::get_file_contents("$data_dir/lsearchres_loc_prem.html");
$nomatch = acs::get_file_contents("$data_dir/nomatch.html");


print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<script LANGUAGE="JavaScript">
<!-- Hide

  function popup(loc,ww,hh)
   {
    var mywidth = (ww + 0);
    var myheight = (hh + 0);

    var winl = (screen.width-ww)/2;
	 var wint = (screen.height-hh)/2;
    
    var myspecs = 'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=' + mywidth + ',height=' + myheight + ',top=' + wint + ',left=' + winl;
	var random = parseInt(Math.random()*10000)

	  var popupwin = null;
      myWindow = open (loc, popupwin + random, myspecs);
      myWindow.moveTo(100,40);
      myWindow.focus();

    }
// End Hide -->
</script>
<body>
$hbox



<form method="POST" action="$admin_url/p_specsearch.cgi">
  <input type="hidden" name="fct" value="create_custom_tset_final">
  <input type="hidden" name="tname" value="$tname">
  
  
  <table width="100%" border="0"
  cellpadding="6" cellspacing="1" bordercolor="#DDDDDD"
  style="border: 1px solid rgb(225,225,225)">
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext" background="$web_url/bar6.gif"><strong>Main
      Search Page</strong></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext">This is the main template acting as
      a frame around Search Results.<br>
      <img src="$web_url/lar3.gif"><a href="popup('$admin_url/admin78.cgi?t=searchres&fct=explain&body=true"
      onClick="popup('$admin_url/admin78.cgi?t=searchres&fct=explain&body=true',screen.width-250,screen.height-250);return false;">
      Explanation of Variables used inside
      this template</a></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><textarea rows="22" name="searchres"
      cols="98"  style="width:100%">$searchres</textarea></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext" background="$web_url/bar6.gif"><strong>Links
      Style</strong></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext">This template is used when
      displaying matched links after a search. <br>
      <img src="$web_url/lar3.gif"><a href="$admin_url/admin78.cgi?t=lsearchres_loc&fct=explain&body=true"
       onClick="popup('$admin_url/admin78.cgi?t=lsearchres_loc&fct=explain&body=true',screen.width-250,screen.height-250);return false;">Explanation of Variables used inside
      this template</a></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><textarea rows="22"
      name="lsearchres_loc" cols="98"  style="width:100%">$lsearchres_loc</textarea></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext" background="$web_url/bar6.gif"><strong>Premium
      Links Style</strong></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext">This template is used when
      displaying premium link listings in search results.<br>
      <img src="$web_url/lar3.gif"><a href="$admin_url/admin78.cgi?t=lsearchres_loc_prem&fct=explain&body=true"
      onClick="popup('$admin_url/admin78.cgi?t=lsearchres_loc_prem&fct=explain&body=true',screen.width-250,screen.height-250);return false;">Explanation of Variables used inside
      this template</a></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><textarea rows="22"
      name="lsearchres_loc_prem" cols="98"  style="width:100%">$lsearchres_loc_prem</textarea></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext" background="$web_url/bar6.gif"><strong>No
      Match</strong></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext">This template is displayed when a
      search revealed no matches. In order to use this template.<br>
      <img src="$web_url/lar3.gif"><a href="$admin_url/admin78.cgi?t=nomatch&fct=explain&body=true"
      onClick="popup('$admin_url/admin78.cgi?t=nomatch&fct=explain&body=true',screen.width-250,screen.height-250);return false;">Explanation of Variables used inside
      this template</a></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"  style="width:100%"><textarea rows="22" name="nomatch"
      cols="98" style="width:100%">$nomatch</textarea></td>
    </tr>
    <tr>
      <td valign="top" bgcolor="#FFFFFF" class="normaltext"><input type="submit"
      value="   Create Template Set   " name="B1"></td>
    </tr>
  </table>
</form>

</body>
</html>
];

}




sub ctemplates
{

$hbox = acs::get_heading_box("$web_url/ic_searchc4.gif", "Specialised Search Template Sets", qq[
This section allows you to create 'Specialised Search Template Sets'. It enables you to use a unique set of templates for the 'Specialised Searches' you create so that they may have a unique look and feel. 
Note that when a 'Specialised Search' is set to use the 'Default' template set that the default search templates that PowerSeek uses are used. These templates
can be edited when clicking the 'Template Manager' tab and then clicking on '2. Search Result Templates'.
<BR><BR>
<b><a href="$admin_url/p_specsearch.cgi?fct=adv_start">Setup/Configure Advanced Specialised Searches</a> >> Specialised Search Template Sets</b>
]);


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sth = $dbh->prepare("SELECT * FROM advsearchtmpl ORDER BY tid");
$sth->execute; 
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}
while ( @row = $sth->fetchrow() )
	{
	$tid = $row[0];
	$template_name = $row[1];

$template_middle_table = $template_middle_table . qq[
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td width="70%" class="normaltext">$template_name</td>
    <td width="15%" align="center" class="normaltext"><a href="$admin_url/p_specsearch.cgi?fct=edit_cust_tmpl&tid=$tid">Edit</a></td>
    <td width="15%" align="center" class="normaltext"><a href="$admin_url/p_specsearch.cgi?fct=del_cust_tmpl&tid=$tid">Delete</a></td>
  </tr>
];
  
	}

$sth->finish;
$dbh->disconnect;


if ($template_middle_table ne "")
{
$set_table = qq[

<table border="0" cellpadding="6" cellspacing="1" width="100%"
style="border: 1px solid rgb(218,218,218)">
  <tr>
    <td width="70%" valign="top" class="normaltext" background="$web_url/bar6.gif"><strong>Name
    of Custom Search Template Set:</strong></td>
    <td width="15%" align="center" valign="top" class="normaltext"
    background="$web_url/bar6.gif"><strong>Edit</strong></td>
    <td width="15%" align="center" valign="top" class="normaltext"
    background="$web_url/bar6.gif"><strong>Delete</strong></td>
  </tr>
$template_middle_table
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>
];
}
else
{
$set_table = qq[<table border="0" cellpadding="6" cellspacing="1" width="100%"
style="border: 1px solid rgb(218,218,218)">
  <tr>
    <td width="100%" valign="top" class="normaltext"><strong>There are currently no Custom
    Search Templates Sets.</strong></td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>];
}


$create_templates = qq[
<form method="POST" action="$admin_url/p_specsearch.cgi">
  <input type="hidden" name="fct" value="create_custom_tset"><table border="0"
  cellpadding="6" cellspacing="1" width="100%" style="border: 1px solid rgb(218,218,218)">
    <tr>
      <td width="100%" valign="top" class="normaltext" colspan="2"
      background="$web_url/bar6.gif"><strong>Create New Custom Search Template Set:</strong></td>
    </tr>
    <tr>
      <td width="38%" class="normaltext">Choose a Name for the Custom Search Template Set:</td>
      <td width="62%" class="normaltext"><input type="text" name="tname" size="48"></td>
    </tr>
    <tr>
      <td width="38%" class="normaltext"></td>
      <td width="62%" class="normaltext"><input type="submit" value="  Next  " name="B1"></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
    <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
  </table>

</form>

];


print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
$set_table
$create_templates
</body>
</html>
];


}




sub save_adv_search
{

$id = $q->param('id');

for ($ms = 0; $ms < 20; $ms++) 
	{
	$cname = "C" . $ms;
	
	if ($q->param($cname) ne "") 
			{
			$found_checked = "true"; 
			
			$kname = "keywords" . $ms;
			
			if ($q->param($kname) eq "")
				{
				acs::problem_popup("You have checked on of the checkboxes but supplied no 'Keyword Field Name'");
				}
			
			########
			for ($mslet = 0; $mslet < length($q->param($kname)); $mslet++) 
				{
				$oneletter = substr($q->param($kname), $mslet, 1);
				if ($oneletter !~ /[0-9a-zA-Z]/)
					{
					acs::problem_popup("One of the 'keyword field names' contains characters other than numerical or alphabetical. You can only use numerical or alphabetical characters in the 'Keyword Field Name'.");
					}
				} 
			#######
			}
	
	}

if ($found_checked ne "true")
	{
	acs::problem_popup("You have to at least select 1 checkbox to create the specialised search.");
	}


##################


for ($ms = 0; $ms < 20; $ms++) 
{

	$field_upd = "field" . $ms;
	$field_pas = "fields" . $ms;
	$field_val = $q->param($field_pas);
	
	$matchtype_upd = "matchtype" . $ms; 
	$matchtype_pas = "match" . $ms; 
	$matchtype_val = $q->param($matchtype_pas);
	
	$keyword_upd = "keyword" . $ms; 
	$keyword_pas = "keywords" . $ms; 
	$keyword_val = $q->param($keyword_pas);
	
	$andor_upd = "andor" . $ms; 
	$andor_val = $q->param($andor_upd);

	$cname = "C" . $ms;
	if ($q->param($cname) ne "") 
	{	
	$update_sql = $update_sql . 	"$field_upd = '$field_val', 
											 $matchtype_upd = '$matchtype_val',
											 $keyword_upd = '$keyword_val',
											 $andor_upd = '$andor_val',
											 ";
	}
	else
	{
	$update_sql = $update_sql . 	"$field_upd = '', 
											 $matchtype_upd = '',
											 $keyword_upd = '',
											 $andor_upd = '',
											 ";	
	}

}


$sortfield = $q->param('sortfield');
$ascdesc = $q->param('ascdesc');
$limit_res = $q->param('limit_res');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sql = "UPDATE advsearcht SET $update_sql fsortby = '$sortfield', ascdesc = '$ascdesc', flimitby = '$limit_res' WHERE searchid = '$id'";

#print $sql . "\n\n\n\n<BR><BR>";

$sth = $dbh->prepare($sql);
$sth->execute; 
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";}

$sth->finish;
$dbh->disconnect;


$hbox = acs::get_heading_box("$web_url/ic_search2.gif", "Specialised Search Saved", qq[
<a href="$admin_url/p_specsearch.cgi?fct=adv_start">Click Here to Continue</a>
]);



($theform, $fnotes) = &create_search_form($id);

$theform_test = $theform;
$theform_test =~ s/><input type=/target="_blank"><input type=/gi;


print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox


<table border="0" cellpadding="6" cellspacing="1" width="100%"
style="border: 1px solid rgb(218,218,218)">
  <tr>
    <td width="60%" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Do a Test Search:</strong></td>
  </tr>
  <tr>
    <td width="60%" valign="top" class="normaltext"><p>$theform_test</p>
      </td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>

<table border="0" cellpadding="6" cellspacing="1" width="100%"
style="border: 1px solid rgb(218,218,218)">
  <tr>
    <td width="60%" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Copy
    and Paste The HTML Code below into a Web Page or any PowerSeek Template</strong></td>
  </tr>
  <tr>
    <td width="60%" valign="top" class="normaltext">
    <form method="POST" action="$script_url/spcsearch.cgi">
    <textarea rows="7" name="S1" cols="58" style="width:100%">$theform</textarea>
    </form></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>

$fnotes




</body>
</html>
];




}



sub edit_search
{

$id = $q->param('id');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 


$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;



@cleanup_fields = ('!!cname!!', '!!lnkid!!', '!!cid!!', '!!title!!', '!!description!!', '!!keywords!!', '!!url!!', '!!name!!', '!!email!!', '!!rating!!', '!!votes!!', 
'!!hits!!', '!!premium!!', '!!userid!!', '!!urldate!!', '!!rev_no!!');



### GET EXTRA FIELD DETAILS
foreach $k_item (@akeys)
	{
	($keyname, $visible, $size, $searched, $description1, $na, $imgk, $numberfield, $req, $allow_html, $carriage_pagebreak) = split (/\t/, $k_item);
	$knvalue = $keyname . "_cust";
	$keydetails = $keydetails . qq[<option !!$knvalue!! value="$knvalue">$description1</option>];
	
	push(@cleanup_fields, "!!$knvalue!!");
	}

$field_options = qq[
<tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><td width="35%" class="normaltext">
<input type="checkbox" name="!!cname!!" value="Y" checked>
<select name="!!fname!!" size="1">
	<option !!title!! value="title">Link Title</option>
	<option !!description!! value="description">Description</option>
	<option !!keywords!! value="keywords">Keywords</option>
	<option !!url!! value="url">URL</option>
	<option !!name!! value="name">Contact Person</option>
	<option !!email!! value="email">Email Address</option>
	<option !!rating!! value="rating">Rating</option>
	<option !!votes!! value="votes">Votes</option>
	<option !!hits!! value="hits">Hits</option>
	<option !!premium!! value="premium">Premium Link Position</option>
	<option !!urldate!! value="urldate">Creation Date (dd/mm/yy)</option>
	<option !!rev_no!! value="rev_no">Number of Comments/Reviews</option>
	<option !!lnkid!! value="lnkid">Link ID</option>
	<option !!cid!! value="cid">Category ID</option>
	<option !!userid!! value="userid">User ID</option>	
	$keydetails
</select>
</td>
<td width="25%" align="center" class="normaltext">
<select name="!!match_opname!!" size="1">
 <option value="LIKE" !!like!!>LIKE</option> 
 <option value="=" !!eq!!>=</option>
 <option value="&gt;" !!g1!!>&gt;</option>
 <option value="&lt;" !!g2!!>&lt;</option>
 <option value="&gt;=" !!g3!!>&gt;=</option>
 <option value="&lt;=" !!g4!!>&lt;=</option>
</select>
</td>
<td width="10%" align="center" class="normaltext"><input type="text" name="!!kfieldname!!" size="20" value="!!kfieldname_val!!"></td>
<td width="10%" align="center" valign="top" class="normaltext"><select name="!!andorname!!" size="1">
<option value="AND" !!and!!>AND</option>
<option value="OR" !!or!!>OR</option>
</select>
</td>
</tr>
];



####  GET ADVANCED SEARCH DETAILS FOR QUERY

$sql = "SELECT * FROM advsearcht WHERE searchid = '$id'";
$sth = $dbh->prepare($sql);
$sth->execute; 
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 	

while ( @row = $sth->fetchrow() )
	{
	$searchname = $row[1];
	
		$fieldnr = 2;
		for ($ms = 2; $ms < 32; $ms++) 
		{
		
		if ($row[$fieldnr] ne "") 
				{
				$add_val = $row[$fieldnr] . ":::" . $row[$fieldnr+1] . ":::" . $row[$fieldnr+2] . ":::" . $row[$fieldnr+3];
				push (@search_lines, "$add_val"); 
				}
		
		$fieldnr = $fieldnr + 4;
		}
	
	$fsortby = $row[122];
	$ascdesc = $row[123];
	$flimitby = $row[124];
	
	}

$sth->finish;
$dbh->disconnect;



### FOR SORT BY FIELDS
@stanfields = ('lnkid', 'cid', 'title', 'description', 'keywords', 'url', 'name', 'email', 'rating', 'votes', 'hits', 'premium', 'userid', 'urldate', 'rev_no');

foreach $stfield (@stanfields)
	{
	if ($fsortby eq $stfield)
		{
		$obj{$fsortby} = "selected";
		}
	}

foreach $k_item (@akeys)
	{
	($keyname, $visible, $size, $searched, $description1, $na, $imgk, $numberfield, $req, $allow_html, $carriage_pagebreak) = split (/\t/, $k_item);
	$keyname = $keyname . "_cust";

		if ($fsortby eq $keyname)
			{
			$extra_sort_fields = $extra_sort_fields . qq[<option value="$keyname" selected>$description1</option>];
			}
			else
			{
			$extra_sort_fields = $extra_sort_fields . qq[<option value="$keyname">$description1</option>];
			}
	}






### BUILD QUERY TABLE

$fnnr = 0;
foreach $item (@search_lines)
	{
	
	($fieldname, $match, $field_box_name, $andor) = split (/:::/, $item);

	$tmp_options = $field_options;
	
		$field_rep_name = "fields" . $fnnr;
		$tmp_options =~ s/!!fname!!/$field_rep_name/gi;
	
		$fieldname_sel = "!!" . $fieldname . "!!";
		$tmp_options =~ s/$fieldname_sel/selected/gi;
		
		$cname_val = "C" . $fnnr . "";
		$tmp_options =~ s/!!cname!!/$cname_val/gi;
		
		$match_rep_name = "match" . $fnnr;
		$tmp_options =~ s/!!match_opname!!/$match_rep_name/gi;
	
		if ($match eq "LIKE") { $tmp_options =~ s/!!like!!/selected/gi; }
		if ($match eq "=") { $tmp_options =~ s/!!eq!!/selected/gi; }
		if ($match eq ">") { $tmp_options =~ s/!!g1!!/selected/gi; }
		if ($match eq "<") { $tmp_options =~ s/!!g2!!/selected/gi; }
		if ($match eq ">=") { $tmp_options =~ s/!!g3!!/selected/gi; }
		if ($match eq "<=") { $tmp_options =~ s/!!g4!!/selected/gi; }
		
		$tmp_options =~ s/!!like!!//gi;
		$tmp_options =~ s/!!eq!!//gi;
		$tmp_options =~ s/!!g1!!//gi;
		$tmp_options =~ s/!!g2!!//gi;
		$tmp_options =~ s/!!g3!!//gi;
		$tmp_options =~ s/!!g4!!//gi;

		$kfield_rep_name = "keywords" . $fnnr;
		$tmp_options =~ s/!!kfieldname!!/$kfield_rep_name/gi;		
		$tmp_options =~ s/!!kfieldname_val!!/$field_box_name/gi;		
		
		
		$andor_rep = "andor" . $fnnr;
		$tmp_options =~ s/!!andorname!!/$andor_rep/gi;
		if ($andor eq "AND") { $tmp_options =~ s/!!and!!/selected/gi; }
		if ($andor eq "OR") { $tmp_options =~ s/!!or!!/selected/gi; }
		$tmp_options =~ s/!!and!!//gi;
		$tmp_options =~ s/!!or!!//gi;
		

	### CLEAN HTML
	
		foreach $toclean (@cleanup_fields)
			{
			$tmp_options =~ s/$toclean//gi;
			}
	
	
	$table_middle = $table_middle . $tmp_options;
	
	$fnnr++;
	}



###############


foreach $toclean (@cleanup_fields)
		{
		$keydetails =~ s/$toclean//gi;
		}


for ($ms = $fnnr; $ms < 20; $ms++) 
	{
	$cname = "C" . $ms;
	$fname = "fields" . $ms;
	$match_opname = "match" . $ms;
	$kfieldname = "keywords" . $ms;
	$andorname = "andor" . $ms;
	
$table_middle = $table_middle . qq[

<tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><td width="35%" class="normaltext">
<input type="checkbox" name="$cname" value="Y"><select name="$fname" size="1">
	<option value="title">Link Title</option>
	<option value="description">Description</option>
	<option value="keywords">Keywords</option>
	<option value="url">URL</option>
	<option value="name">Contact Person</option>
	<option value="email">Email Address</option>
	<option value="rating">Rating</option>
	<option value="votes">Votes</option>
	<option value="hits">Hits</option>
	<option value="premium">Premium Link Position</option>
	<option value="urldate">Creation Date (dd/mm/yy)</option>
	<option value="rev_no">Number of Comments/Reviews</option>
	<option value="lnkid">Link ID</option>
	<option value="cid">Category ID</option>
	<option value="userid">User ID</option>	
	$keydetails
</select>
</td>
<td width="25%" align="center" class="normaltext">
<select name="$match_opname" size="1">
 <option value="LIKE">LIKE</option> 
 <option value="=">=</option>
 <option value="&gt;">&gt;</option>
 <option value="&lt;">&lt;</option>
 <option value="&gt;=">&gt;=</option>
 <option value="&lt;=">&lt;=</option>
</select>
</td>
<td width="10%" align="center" class="normaltext"><input type="text" name="$kfieldname" size="20"></td>
<td width="10%" align="center" valign="top" class="normaltext"><select name="$andorname" size="1">
<option value="AND">AND</option>
<option value="OR">OR</option>
</select>
</td>
</tr>
	
];

	}



if ($ascdesc eq "ASC") { $asc_selected = "selected"; }
elsif ($ascdesc eq "DESC") { $desc_selected = "selected"; }



$hbox = acs::get_heading_box("$web_url/ic_searchc2.gif", "Edit Specialised Search", qq[
Name For This Search: <B>$searchname</b><BR>
<b><a href="$admin_url/p_specsearch.cgi?fct=adv_start">Go Back</a></b>
]);


print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
<b><span class="normaltext">SELECT FROM links WHERE:</span></b><BR><BR>

<form method="POST" action="$admin_url/p_specsearch.cgi">
  <input type="hidden" name="fct" value="save_adv_search">
  <input type="hidden" name="id" value="$id">

<table border="0" cellpadding="6" cellspacing="1" width="100%" style="border: 1px solid rgb(218,218,218)">
    <tr>
      <td width="35%" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>(Click the checkbox to use)</strong></td>
      <td width="25%" align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Match Type</strong></td>
      <td width="10%" align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Keyword Field Name</strong></td>
      <td width="10%" align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>AND/OR</strong></td>
    </tr>

$table_middle 
    
  </table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>



<table border="0" cellpadding="6" cellspacing="1" width="100%"
style="border: 1px solid rgb(218,218,218)">
  <tr>
    <td width="80%" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Sort
    The Matching Records By:</strong></td>
  </tr>
  <tr>
    <td width="80%" valign="top" class="normaltext"><select name="sortfield" size="1">
      <option value="title" $obj{'title'}>Link Title</option>
      <option value="description" $obj{'description'}>Description</option>
      <option value="keywords" $obj{'keywords'}>Keywords</option>
      <option value="url" $obj{'url'}>URL</option>
      <option value="name" $obj{'name'}>Contact Person</option>
      <option value="email" $obj{'email'}>Email Address</option>
      <option value="rating" $obj{'rating'}>Rating</option>
      <option value="votes" $obj{'votes'}>Votes</option>
      <option value="hits" $obj{'hits'}>Hits</option>
      <option value="premium" $obj{'premium'}>Premium Link Position</option>
      <option value="urldate" $obj{'urldate'}>Creation Date (dd/mm/yy)</option>
      <option value="rev_no" $obj{'rev_no'}>Number of Comments/Reviews</option>
      <option value="lnkid" $obj{'lnkid'}>Link ID</option>
      <option value="cid" $obj{'cid'}>Category ID</option>
      <option value="userid" $obj{'userid'}>User ID</option>      
      $extra_sort_fields
    </select> <select name="ascdesc" size="1">
      <option value="ASC" $asc_selected>Ascending</option>
      <option value="DESC" $desc_selected>Descending</option>
    </select></td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>

<table border="0" cellpadding="6" cellspacing="1" width="100%"
style="border: 1px solid rgb(218,218,218)">
  <tr>
    <td width="80%" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Limit
    the number of matched results by:</strong></td>
  </tr>
  <tr>
    <td width="80%" valign="top" class="normaltext"><input type="text" name="limit_res"
    size="11" value="$flimitby"> Specify 0 for unlimited results. (Unlimited matches)</td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>



  <p><input type="submit" value="     Save     " name="B1"></p>
</form>


</body>
</html>
];


}



sub create_search_form
{
my ($sid) = @_;

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$sql = "SELECT * FROM advsearcht WHERE searchid = '$sid'";
$sth = $dbh->prepare($sql);
$sth->execute; 
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 	

while ( @row = $sth->fetchrow() )
	{
	$searchname = $row[1];
	
		$fieldnr = 2;
		for ($ms = 2; $ms < 32; $ms++) 
		{
		
		if ($row[$fieldnr] ne "") 
				{
				$add_val = $row[$fieldnr] . ":::" . $row[$fieldnr+1] . ":::" . $row[$fieldnr+2] . ":::" . $row[$fieldnr+3];
				push (@search_lines, "$add_val"); 
				}
		
		$fieldnr = $fieldnr + 4;
		}
	
	}

$sth->finish;
$dbh->disconnect;


### CREATE HTML CODE

$form_start = qq[<form method="POST" action="$script_url/spcsearch.cgi"><input type="hidden" name="id" value="$sid">];

foreach $item (@search_lines)
	{
	($fieldname, $match, $field_box_name, $andor) = split (/:::/, $item);

	$found_box = "false";
	foreach $kitem (@boxnames)
			{
			if ($kitem eq $field_box_name) { $found_box = "true";	}
			}
	
	if ($found_box eq "false")
		{
		push (@boxnames, $field_box_name);
		
		$form_middle = $form_middle . qq[$fieldname !!$field_box_name!!<input type="text" name="$field_box_name" size="20"><BR>];
		}
		else
		{
		$form_middle =~ s/!!$field_box_name!!/ \/ $fieldname !!$field_box_name!!/gi;
		$form_notes = $form_notes . qq[<ul><li class="normaltext">Note that the field box called <b>'$field_box_name'</b> to search the field <b>'$fieldname'</b> can only be used once as you cannot have 2 or more fill-in-boxes with the same name. Although it is used only once the keywords from this fill-in box will still be used to search the <b>'$fieldname'</b> field.</li></ul>];
		}
	
	}


foreach $item (@search_lines)
	{
	($fieldname, $match, $field_box_name, $andor) = split (/:::/, $item);
	$form_middle =~ s/!!$field_box_name!!//gi;
	}



$form_end = qq[<BR><BR><input type="submit" value="Search" name="B1"></form>];


$completed_form = $form_start . $form_middle . $form_end;

return ($completed_form, $form_notes);

}





sub get_search_code
{

$id = $q->param('id');

($theform, $fnotes) = &create_search_form($id);


$hbox = acs::get_heading_box("$web_url/ic_searchc2.gif", "Get Search Form HTML Code For: $searchname", qq[
Feel free to customize the HTML Code for the search form provided below to implement your own look and feel.<BR>You could also for example substitute searhboxes (where keywords are collected) with drop down menu's where appropriate.
<BR><b><a href="$admin_url/p_specsearch.cgi?fct=adv_start">Click Here to go Back</a></b>
]);


$theform_test = $theform;

$theform_test =~ s/><input type=/target="_blank"><input type=/gi;

print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
<table border="0" cellpadding="6" cellspacing="1" width="100%"
style="border: 1px solid rgb(218,218,218)">
  <tr>
    <td width="60%" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Copy
    and Paste The HTML Code below into a Web Page or any PowerSeek Template</strong></td>
  </tr>
  <tr>
    <td width="60%" valign="top" class="normaltext">
    <form method="POST" action="$script_url/spcsearch.cgi">
    <textarea rows="7" name="S1" cols="58" style="width:100%">$theform</textarea>
    </form></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>

$fnotes

<table border="0" cellpadding="6" cellspacing="1" width="100%"
style="border: 1px solid rgb(218,218,218)">
  <tr>
    <td width="60%" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Test Search:</strong></td>
  </tr>
  <tr>
    <td width="60%" valign="top" class="normaltext"><p>$theform_test</p>
      </td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>


</body>
</html>
];




}



sub delete_search
{

$id = $q->param('id');


$hbox = acs::get_heading_box("$web_url/ic_searchc2.gif", "Deleted Search", qq[
<form method="POST" action="$admin_url/p_specsearch.cgi">
  <input type="hidden" name="fct" value="delete_search2"><input type="hidden" name="id"
  value="$id"><p class="normaltext">Are you sure? 
    <input type="submit" value="   Yes   " name="B1">
    <input name="B1" type="submit" value="    No    " onClick="history.go(-1); return false;">
  </p>
</form>
]);


print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

}




sub delete_search2
{

$id = $q->param('id');

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$wsql = "DELETE FROM advsearcht WHERE searchid = '$id'";
$sth = $dbh->prepare($wsql);
$sth->execute; 

$sth->finish;
$dbh->disconnect;

$hbox = acs::get_heading_box("$web_url/ic_searchc2.gif", "Search Deleted", qq[
<a href="$admin_url/p_specsearch.cgi?fct=adv_start">Click Here to Continue</a>
]);


print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];

}





sub create_adv
{


###########


for ($ms = 0; $ms < 20; $ms++) 
	{
	$cname = "C" . $ms;
	
	if ($q->param($cname) ne "") 
			{
			$found_checked = "true"; 
			
			$kname = "keywords" . $ms;
			
			if ($q->param($kname) eq "")
				{
				acs::problem_popup("You have checked a checkbox but supplied no 'Keyword Field Name'");
				}
			
			########
			for ($mslet = 0; $mslet < length($q->param($kname)); $mslet++) 
				{
				$oneletter = substr($q->param($kname), $mslet, 1);
				if ($oneletter !~ /[0-9a-zA-Z]/)
					{
					acs::problem_popup("One of the 'keyword field names' contains characters other than numerical or alphabetical. You can only use numerical or alphabetical characters in the 'Keyword Field Name'.");
					}
				} 
			#######

			}
	
	}

if ($found_checked ne "true")
	{
	acs::problem_popup("You have to at least select 1 checkbox to create the specialised search.");
	}

if ($q->param('search_name') eq "") { acs::problem_popup("You have to provide a name for the search you are about to create."); }


### CHECK ONLY ALPHABETICAL OR NUMERICAL LETTERS IN KEYWORDS BOX


for ($ms = 0; $ms < 30; $ms++) 
	{
	$cname = "C" . $ms;

	if ($q->param($cname) eq "Y")
		{
		$fields_name = "fields" . $ms;
		$match_type_name = "match" . $ms;
		$keyword_name = "keywords" . $ms;
		$and_or_name= "andor" . $ms;

		$insert_sql = $insert_sql . "field" . "$ms" . " = '" . $q->param($fields_name) . "',";
		$insert_sql = $insert_sql . "matchtype" . "$ms" . " = '" . $q->param($match_type_name) . "',";
		$insert_sql = $insert_sql . "keyword" . "$ms" . " = '" . $q->param($keyword_name) . "',";
		$insert_sql = $insert_sql . "andor" . "$ms" . " = '" . $q->param($and_or_name) . "',";
		}

	}

	chop($insert_sql);


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 	

	$search_nm = $dbh->quote($q->param('search_name')); 
	
	$sortfield = $q->param('sortfield');
	$flimitby = $q->param('limit_res');
	$ascdesc = $q->param('ascdesc');


	$sql = "INSERT INTO advsearcht SET searchname = $search_nm, fsortby = '$sortfield', ascdesc = '$ascdesc', flimitby = '$flimitby', $insert_sql";
	#print "--> $sql <BR>";
	$sth = $dbh->prepare($sql);
	$sth->execute; 
	$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 	


$sth = $dbh->prepare("SELECT searchid FROM advsearcht WHERE searchid = LAST_INSERT_ID()");
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}	
while ( @row = $sth->fetchrow() )	
		{
		$last_searchid = $row[0]; 
		}  


$sth->finish;
$dbh->disconnect;





$hbox = acs::get_heading_box("$web_url/ic_searchc2.gif", "Specialised Search Created", qq[

<ul>
  <li><a href="$admin_url/p_specsearch.cgi?fct=get_search_code&id=$last_searchid">Click Here to obtain the HTML Code for the Search Box and to test the Search</a></li>
  <li><a href="$admin_url/p_specsearch.cgi?fct=edit_search&id=$last_searchid">Click Here to edit the Search you just created.</a></li>
  <li><a href="$admin_url/p_specsearch.cgi?fct=adv_start">Click Here to Continue</a></li>
</ul>

]);


print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
</body>
</html>
];


}



sub add_new_advanced
{

if ($q->param('B2') ne "") { &ctemplates; exit; }

$hbox = acs::get_heading_box("$web_url/ic_searchc2.gif", "Set Up An Advanced Specialised Search", qq[
Name of Search: <b>$searchname</b><BR><BR>
<b><a href="$admin_url/p_specsearch.cgi" onClick="history.go(-1); return false;">Go Back</a></b>
]);

#Link ID								lnkid
#Category ID							cid
#Link Title							title
#Description 						description
#Keywords								keywords
#URL									url
#Contact Person						name
#Email Address						email
#Rating								rating
#Votes									votes
#Hits									hits
#Premium Link Position			premium
#User ID								userid
#Date (dd/mm/yy)					urldate
#Number of Comments/Reviews		rev_no



$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

	### GET EXTRA FIELD DETAILS
	foreach $k_item (@akeys)
		{
		($keyname, $visible, $size, $searched, $description1, $na, $imgk, $numberfield, $req, $allow_html, $carriage_pagebreak) = split (/\t/, $k_item);
		$knvalue = $keyname . "_cust";
  		$keydetails = $keydetails . qq[<option value="$knvalue">$description1</option>];
		}



for ($ms = 0; $ms < 20; $ms++) 
	{
	

	
	### STANDARD LINK DETAILS	
	
	$cname = "C" . $ms;
	$fname = "fields" . $ms;
	$match_opname = "match" . $ms;
	$kfieldname = "keywords" . $ms;
	$andorname = "andor" . $ms;
	
$fields_sel_options = $fields_sel_options . qq[<tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';"><td width="35%" class="normaltext">
<input type="checkbox" name="$cname" value="Y">
<select name="$fname" size="1">
	<option value="title">Link Title</option>
	<option value="description">Description</option>
	<option value="keywords">Keywords</option>
	<option value="url">URL</option>
	<option value="name">Contact Person</option>
	<option value="email">Email Address</option>
	<option value="rating">Rating</option>
	<option value="votes">Votes</option>
	<option value="hits">Hits</option>
	<option value="premium">Premium Link Position</option>
	<option value="urldate">Creation Date (dd/mm/yy)</option>
	<option value="rev_no">Number of Comments/Reviews</option>
	<option value="lnkid">Link ID</option>
	<option value="cid">Category ID</option>
	<option value="userid">User ID</option>	
	$keydetails
</select>
</td>
<td width="25%" align="center" class="normaltext"><select name="$match_opname" size="1">
 <option value="LIKE">LIKE</option> 
 <option value="=">=</option>
 <option value="&gt;">&gt;</option>
 <option value="&lt;">&lt;</option>
 <option value="&gt;=">&gt;=</option>
 <option value="&lt;=">&lt;=</option>
</select>
</td>
<td width="10%" align="center" class="normaltext"><input type="text" name="$kfieldname" size="20"></td>
<td width="10%" align="center" valign="top" class="normaltext"><select name="$andorname" size="1">
<option value="AND">AND</option>
<option value="OR">OR</option>
</select>
</td>
</tr>

];


	}


$helpb = acs::quick_help("Quick Help",qq[
<ul>
  <li class="normaltext">It would be highly recommended that you go through the <strong>examples for setting up Advanced Specialised Searches in the PowerSeek documentation.</strong></li>
  <li class="normaltext">The <b>'Keyword Field Name'</b> is a name you choose and would be an actual field where users supply keywords to perform the search.</li>
  <li class="normaltext">Each line (containing a checkbox) above would represent a statement (if checked) where matches will be done on the a database field according to keywords provided by end users.</li>
  <li class="normaltext">The <strong>LIKE</strong> 'Match Type' operator will match words within a phrase or words within a word.</li>
</ul>
<p><span class="normaltext"><strong></strong></span><strong>For detailed instructions with examples on creating Advanced Specialised Searches see the PowerSeek documentation.</strong></p>
]);


print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox

<form method="POST" action="$admin_url/p_specsearch.cgi">
  <input type="hidden" name="fct" value="create_adv">
  <input type="hidden" name="search_name" value="$searchname">


<p><strong>SELECT * FROM links WHERE:</strong><BR>
(The above phrase is the start of the actual SQL query that will be used when this search is being done. The rest of the SQL query will be created according
to the options chosen below. SQL queries are used to create search queries on a database. )
<BR><BR>
</p>

<table border="0" cellpadding="6" cellspacing="1" width="100%" style="border: 1px solid rgb(218,218,218)">
    <tr>
      <td width="35%" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Database Field to Search: (Click the checkbox to use)</strong></td>
      <td width="25%" align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Match Type</strong></td>
      <td width="10%" align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Keyword Field Name</strong></td>
      <td width="10%" align="center" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>AND/OR</strong></td>
    </tr>

$fields_sel_options 
    
  </table>
  
  
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
      <td width="99%"></td>
    </tr>
  </table>

  
<table border="0" cellpadding="6" cellspacing="1" width="100%" style="border: 1px solid rgb(218,218,218)">
    <tr>
      <td width="80%" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Sort
      The Matching Records By:</strong></td>
    </tr>
    <tr>
      <td width="80%" valign="top" class="normaltext"><strong><select name="sortfield" size="1">
		  <option value="title">Link Title</option>
		  <option value="description">Description</option>
		  <option value="keywords">Keywords</option>
		  <option value="url">URL</option>
		  <option value="name">Contact Person</option>
		  <option value="email">Email Address</option>
		  <option value="rating">Rating</option>
		  <option value="votes">Votes</option>
		  <option value="hits">Hits</option>
		  <option value="premium">Premium Link Position</option>
		  <option value="urldate">Creation Date (dd/mm/yy)</option>
		  <option value="rev_no">Number of Comments/Reviews</option>
		  <option value="lnkid">Link ID</option>
		  <option value="cid">Category ID</option>
		  <option value="userid">User ID</option>		  
        $keydetails
      </select></strong> <strong><select name="ascdesc" size="1">
        <option value="ASC">Ascending</option>
        <option value="DESC">Descending</option>
      </select></strong></td>
    </tr>
  </table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>


<table border="0" cellpadding="6" cellspacing="1" width="100%"
style="border: 1px solid rgb(218,218,218)">
  <tr>
    <td width="80%" valign="top" background="$web_url/bar6.gif" class="normaltext"><strong>Limit
    the number of matched results by:</strong></td>
  </tr>
  <tr>
    <td width="80%" valign="top" class="normaltext"><input type="text" name="limit_res"
    size="11"> Specify 0 for unlimited results. (Unlimited matches)</td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>


  <p><input type="submit" value="Create Search" name="B1"><BR><BR></p>
</form>

$helpb

</body>
</html>
];

}




sub adv_start
{

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 

$wsql = "SHOW TABLES";
$sth = $dbh->prepare($wsql);
$sth->execute; 

while ( @row = $sth->fetchrow() )
	{ 
	if ($row[0] eq "advsearcht") { $adv_search_table = "True"; } 
	if ($row[0] eq "advsearchtmpl") { $adv_search_tmpl_table = "True"; } 
	}


if ($adv_search_tmpl_table ne "True")
	{
		$sql = "CREATE TABLE advsearchtmpl
					(
					tid					int NOT NULL auto_increment,
					tmplname				varchar(255),
					PRIMARY KEY(tid)
					)";
							
		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 	
	}


if ($adv_search_table ne "True")
	{
	
	$sql = "CREATE TABLE advsearcht
					(
					searchid				int NOT NULL auto_increment,
					searchname			varchar(255),

					field0				varchar(255),
					matchtype0			varchar(15),
					keyword0				varchar(100),
					andor0				varchar(3),

					field1				varchar(255),
					matchtype1			varchar(15),
					keyword1				varchar(100),
					andor1				varchar(3),

					field2				varchar(255),
					matchtype2			varchar(15),
					keyword2				varchar(100),
					andor2				varchar(3),

					field3				varchar(255),
					matchtype3			varchar(15),
					keyword3				varchar(100),
					andor3				varchar(3),

					field4				varchar(255),
					matchtype4			varchar(15),
					keyword4				varchar(100),
					andor4				varchar(3),

					field5				varchar(255),
					matchtype5			varchar(15),
					keyword5				varchar(100),
					andor5				varchar(3),

					field6				varchar(255),
					matchtype6			varchar(15),
					keyword6				varchar(100),
					andor6				varchar(3),

					field7				varchar(255),
					matchtype7			varchar(15),
					keyword7				varchar(100),
					andor7				varchar(3),

					field8				varchar(255),
					matchtype8			varchar(15),
					keyword8				varchar(100),
					andor8				varchar(3),

					field9				varchar(255),
					matchtype9			varchar(15),
					keyword9				varchar(100),
					andor9				varchar(3),

					field10				varchar(255),
					matchtype10			varchar(15),
					keyword10			varchar(100),
					andor10				varchar(3),

					field11				varchar(255),
					matchtype11			varchar(15),
					keyword11			varchar(100),
					andor11				varchar(3),

					field12				varchar(255),
					matchtype12			varchar(15),
					keyword12			varchar(100),
					andor12				varchar(3),

					field13				varchar(255),
					matchtype13			varchar(15),
					keyword13			varchar(100),
					andor13				varchar(3),

					field14				varchar(255),
					matchtype14			varchar(15),
					keyword14			varchar(100),
					andor14				varchar(3),

					field15				varchar(255),
					matchtype15			varchar(15),
					keyword15			varchar(100),
					andor15				varchar(3),

					field16				varchar(255),
					matchtype16			varchar(15),
					keyword16			varchar(100),
					andor16				varchar(3),

					field17				varchar(255),
					matchtype17			varchar(15),
					keyword17			varchar(100),
					andor17				varchar(3),

					field18				varchar(255),
					matchtype18			varchar(15),
					keyword18			varchar(100),
					andor18				varchar(3),

					field19				varchar(255),
					matchtype19			varchar(15),
					keyword19			varchar(100),
					andor19				varchar(3),

					field20				varchar(255),
					matchtype20			varchar(15),
					keyword20			varchar(100),
					andor20				varchar(3),

					field21				varchar(255),
					matchtype21			varchar(15),
					keyword21			varchar(100),
					andor21				varchar(3),

					field22				varchar(255),
					matchtype22			varchar(15),
					keyword22			varchar(100),
					andor22				varchar(3),

					field23				varchar(255),
					matchtype23			varchar(15),
					keyword23			varchar(100),
					andor23				varchar(3),

					field24				varchar(255),
					matchtype24			varchar(15),
					keyword24			varchar(100),
					andor24				varchar(3),

					field25				varchar(255),
					matchtype25			varchar(15),
					keyword25			varchar(100),
					andor25				varchar(3),

					field26				varchar(255),
					matchtype26			varchar(15),
					keyword26			varchar(100),
					andor26				varchar(3),

					field27				varchar(255),
					matchtype27			varchar(15),
					keyword27			varchar(100),
					andor27				varchar(3),

					field28				varchar(255),
					matchtype28			varchar(15),
					keyword28			varchar(100),
					andor28				varchar(3),

					field29				varchar(255),
					matchtype29			varchar(15),
					keyword29			varchar(100),
					andor29				varchar(3),

					fsortby				varchar(255),
					ascdesc				varchar(5),
					flimitby				int,
					template				varchar(255),
					sql_qq				text,
					
					PRIMARY KEY(searchid)
					)";
							
		$sth = $dbh->prepare($sql);
		$sth->execute;
		$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 	
	} 


$sql = "SELECT * FROM advsearchtmpl";
$sth = $dbh->prepare($sql);
$sth->execute; 
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 	

	while ( @row = $sth->fetchrow() )
		{ 
		$tmpl_obj{$row[0]} = "$row[1]";
		}


$sql = "SELECT * FROM advsearcht";
$sth = $dbh->prepare($sql);
$sth->execute; 
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 	

	while ( @row = $sth->fetchrow() )
		{ 
		$search_id = $row[0];
		$search_name = $row[1];
		$template = $row[125];

		if ($template eq "") { $template_in_use = "Default";	}
		else { $template_in_use = $tmpl_obj{$template}; }


if ($row[2] eq "")
	{
$search_lines = $search_lines . qq[
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td width="30%" class="normaltext">$search_name</td>
    <td width="20%" align="center" class="normaltext"><a href="$admin_url/p_specsearch.cgi?fct=get_search_codesql&id=$search_id">Get HTML Code</a></td>
    <td width="7%" align="center" class="normaltext">SQL</td>
    <td width="8%" align="center" class="normaltext"><a href="$admin_url/p_specsearch.cgi?fct=edit_searchsql&id=$search_id">Edit</a></td>
    <td width="20%" align="center" valign="top" class="normaltext"><a href="$admin_url/p_specsearch.cgi?fct=assign_template&id=$search_id" onClick="popup('$admin_url/p_specsearch.cgi?fct=assign_template&id=$search_id',600,400);return false;">$template_in_use</a></td>
    <td width="10%" align="center" valign="top" class="normaltext"><a href="$admin_url/p_specsearch.cgi?fct=delete_search&id=$search_id">Delete</a></td>
  </tr>
];
	}
	else
	{
$search_lines = $search_lines . qq[
  <tr onMouseOver="this.bgColor='#F7F7F7';" onMouseOut="this.bgColor='#FFFFFF';">
    <td width="30%" class="normaltext">$search_name</td>
    <td width="20%" align="center" class="normaltext"><a href="$admin_url/p_specsearch.cgi?fct=get_search_code&id=$search_id">Get HTML Code</a></td>
    <td width="7%" align="center" class="normaltext">Automated</td>
    <td width="8%" align="center" class="normaltext"><a href="$admin_url/p_specsearch.cgi?fct=edit_search&id=$search_id">Edit</a></td>
    <td width="20%" align="center" valign="top" class="normaltext"><a href="$admin_url/p_specsearch.cgi?fct=assign_template&id=$search_id" onClick="popup('$admin_url/p_specsearch.cgi?fct=assign_template&id=$search_id',600,400);return false;">$template_in_use</a></td>
    <td width="10%" align="center" valign="top" class="normaltext"><a href="$admin_url/p_specsearch.cgi?fct=delete_search&id=$search_id">Delete</a></td>
  </tr>
];
	
	}

		
}

$sth->finish;
$dbh->disconnect;


if ($search_lines ne "")
	{

$saerches_table = qq[
<table border="0" cellpadding="6" cellspacing="1" width="100%" style="border: 1px solid rgb(218,218,218)">
  <tr>
    <td width="30%" valign="top" class="normaltext" background="$web_url/bar6.gif"><strong>Search Name:</strong></td>
    <td width="20%" align="center" valign="top" class="normaltext" background="$web_url/bar6.gif"><strong>Get Search Box HTML Code</strong></td>
    <td width="7%" align="center" valign="top" class="normaltext" background="$web_url/bar6.gif"><strong>Type</strong></td>
    <td width="8%" align="center" valign="top" class="normaltext" background="$web_url/bar6.gif"><strong>Edit</strong></td>
    <td width="20%" align="center" valign="top" class="normaltext" background="$web_url/bar6.gif"><a href="$admin_url/p_specsearch.cgi?fct=ctemplates"><strong>Template Set</strong></a></td>
    <td width="10%" align="center" valign="top" class="normaltext" background="$web_url/bar6.gif"><strong>Delete Search</strong></td>
  </tr>
$search_lines
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>

];
	}
	else
	{
	$saerches_table = qq[<table border="0" cellpadding="6" cellspacing="1" width="100%"
style="border: 1px solid rgb(218,218,218)">
  <tr>
    <td width="100%" valign="top" class="normaltext"><p
    align="center"><strong>No Searches has been created yet.</strong></td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>
];
	
	}



$hbox = acs::get_heading_box("$web_url/ic_searchc2.gif", "Setup/Configure Advanced Specialised Searches", qq[
This functionality enables you to create specialised searches. It enables you to specify specific fields that is to be searched with specific search boxes.
Due to this functionality being very flexible it would be highly recommended that you go through the <b>examples available in the PowerSeek documentation </b>
to get a good understanding on how to create specialised searches.<BR>
<b><a href="$admin_url/p_specsearch.cgi">Go Back</a></b>
]);


print qq[<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">

<script LANGUAGE="JavaScript">
<!-- Hide

  function popup(loc,ww,hh)
   {
    var mywidth = (ww);
    var myheight = (hh);

    var winl = (screen.width-ww)/2;
	 var wint = (screen.height-hh)/2;
	 
    var myspecs = 'menubar=0,status=1,resizable=1,location=0,titlebar=1,toolbar=1,scrollbars=1,width=' + mywidth + ',height=' + myheight + ',top=' + wint + ',left=' + winl;
	 var random = parseInt(Math.random()*10000)

	  var popupwin = null;
      myWindow = open (loc, popupwin + random, myspecs);
      myWindow.moveTo(100,40);
      myWindow.focus();

    }
// End Hide -->
</script>

</head>
<body>
$hbox
$saerches_table

<form method="POST" action="$admin_url/p_specsearch.cgi">
  <input type="hidden" name="fct" value="choose_search_create"><p><input type="submit"
  value="Add a New Advanced Search" name="B1"> <input type="submit"
  value="Create or Edit Specialised Search Template Sets" name="B2"></p>
</form>



</body>
</html>
];

#add_new_advanced

}



sub get_search_form
{

$title = $q->param('title');
$diz = $q->param('diz');
$kw = $q->param('kw');
$url = $q->param('url');
$mtype = $q->param('mtype');

if ($title eq "title") { $title_hv = qq[<input type="hidden" name="title" value="title">\n]; }
if ($diz eq "description") { $description_hv = qq[<input type="hidden" name="diz" value="description">\n]; }
if ($kw eq "keywords") { $keywords_hv = qq[<input type="hidden" name="kw" value="keywords">\n]; }
if ($url eq "url") { $url_hv = qq[<input type="hidden" name="url" value="url">\n]; }




$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

foreach $k_item (@akeys)
		{
		($keyname, $visible, $size, $searched, $description1, $na, $imgk) = split (/\t/, $k_item);

		if ($q->param($keyname) eq $keyname)
			{
			$extra_key_boxes = $extra_key_boxes . qq[<input type="hidden" name="$keyname" value="$keyname">\n];
			}
		}



## CREATE FORM

$sform = qq[<form method="POST" action="$script_url/search.cgi">
<input type="hidden" name="fct" value="advanced">
<input type="hidden" name="mtype" value="$mtype"> $title_hv $description_hv $keywords_hv $url_hv
$extra_key_boxes <input type="text" name="keywords" size="59" value> <input type="submit" value="Search" name="B1">
</form>
];


$hbox = acs::get_heading_box("$web_url/ic_searchc1.gif", "Specialized Search Created", qq[
Copy and Past the HTML code below into any web page or any PowerSeek template to provide the specialized search you just created to your Search Engine & Directory visitors.<BR>
<a href="$admin_url/p_specsearch.cgi" onClick="history.go(-1); return false;"><b>Go Back</b></a>
]);


print qq[
<html>

<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>

<body>

$hbox



<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DADADA">
  <tr>
    <td width="100%" height="30" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>HTML
    Code: </strong></td>
  </tr>
  <tr>
    <td width="100%" height="30" bgcolor="#FFFFFF" valign="top"><form method="POST"
    action="--WEBBOT-SELF--">
      <span class="normaltext">
      <!--webbot bot="SaveResults" startspan U-File="_private/form_results.txt"
      S-Format="TEXT/CSV" S-Label-Fields="TRUE" -->
      <!--webbot bot="SaveResults" endspan -->
      </span>
      <div
      align="center"><center><p class="normaltext">
        <textarea rows="18" name="S1" cols="59" style="width:100%">$sform</textarea>
      </p>
      </center></div>
    </form>    </td>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>

<p align="center" class="normaltext"><a href="$admin_url/p_specsearch.cgi"><strong>Go back </strong></a></p>

</body>
</html>
];


}




sub start
{

$hbox = acs::get_heading_box("$web_url/ic_search2.gif", "Specialized Search Creator ", qq[
Choose an option below.
]);


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
$hbox

<table border="0" cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD"
height="46">
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="30" align="center"><img
    src="$web_url/ic_searchc1.gif"></td>
    <td width="99%" height="80" bgcolor="#FFFFFF" class="normaltext"><a
    href="$admin_url/p_specsearch.cgi?fct=start2"><b>Setup/Configure a Simple Specialised
    Search</b></a><br>
    With this option you can create searches that search specified fields or extra fields.</td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="30" align="center"><img
    src="$web_url/ic_searchc2.gif"></td>
    <td width="99%" height="80" bgcolor="#FFFFFF" class="normaltext"><a
    href="$admin_url/p_specsearch.cgi?fct=adv_start"><b>Setup/Configure Advanced Specialised
    Searches</b></a><br>
    This functionality enables you to set up searches that will for example search price
    ranges, certain fields combined with others, etc. Combined with extra fields you can
    almost create any kind of search.</td>
  </tr>
  <tr>
    <td width="1%" bgcolor="#FFFFFF" height="30" align="center"><img
    src="$web_url/ic_searchc5.gif"></td>
    <td width="99%" height="80" bgcolor="#FFFFFF" class="normaltext"><strong><a
    href="$admin_url/p_specsearch.cgi?fct=cat_search_start"
    onclick="popup('$admin_url/p_specsearch.cgi?fct=cat_search_start',(screen.width - 200),(screen.height - 200));return false;">Create/Configure
    Specific Category Searches</a><br>
    </strong>Create searches where the search will be narrowed to a specified category and
    it's sub categories.</td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%"
background="$web_url/shadow.gif">
  <tr>
    <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td>
    <td width="99%"></td>
  </tr>
</table>

</body>
</html>
];

}



sub cat_search_start
{


$hbox = acs::get_heading_box("$web_url/ic_searchc5.gif", "Create/Configure Specific Category Searches", qq[
Allows you to create searches that will only search specific categories.<BR>
<BR><b>Instructions:</b><BR>
Select a category. In the HTML code box below there will be HTML code that you can place inside any web page or PowerSeek template to have visitors search the category you selected.
<BR><BR>
<b><a href="$admin_url/p_specsearch.cgi">Go Back</a></b>
]);


print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>
$hbox
];



$ct = $q->param('ct'); ### ORIGINAL CAT
$cid = $q->param('cid'); ### ORIGINAL CID
$rid = $q->param('rid'); ### ORIGINAL RID

$mct = $q->param('mct'); ### TO MOVE TO CAT
$mlv = $q->param('mlv'); ### TO MOVE LEVEL
$mcid = $q->param('mcid'); ### TO MOVE CID


if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
 
########

if ($mlv == 0)
	{
	$sth = $dbh->prepare("SELECT * FROM dirs WHERE (level = '1') AND ((crosslinkid IS NULL) OR (crosslinkid < 1)) ORDER BY shortname ASC");
	}
	else
	{
	$mlv++;
	@adir = split (/-/, $mct);
	
	$querystr = "";

	for ($ms = 0; $ms < 16; $ms++) 
		{
		if ($adir[$ms] ne "") {$adir[$ms] = acs::decode_dir($adir[$ms]);}

		$acnt = $ms + 1;
		if ($acnt != $mlv)
			{
			if ($adir[$ms] ne "")
				{
				$adir[$ms] =~ s/'/\\'/g;
				}
			$querystr = $querystr . " (l" . "$acnt = '$adir[$ms]') and";
			}
		$acnt++;
		}
	$querystr = substr($querystr, 0, length($querystr) - 3);
	$sth = $dbh->prepare("SELECT * FROM dirs WHERE (level = '$mlv') AND $querystr AND ((crosslinkid IS NULL) OR (crosslinkid < 1)) ORDER BY shortname ASC");
	
	}

##############

if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n"; }

$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}
$rows = $sth->rows();

$smc = 0;
while ( @row = $sth->fetchrow() )
	{
	$mlv = $row[1];

	$row[2] = acs::encode_dir($row[2]); $dirstring = $row[2];														#1
	if ($row[3] ne "") { $row[3] = acs::encode_dir($row[3]); $dirstring =   $dirstring . "-$row[3]"; } #2
	if ($row[4] ne "") { $row[4] = acs::encode_dir($row[4]); $dirstring =   $dirstring . "-$row[4]"; } #3
	if ($row[5] ne "") { $row[5] = acs::encode_dir($row[5]); $dirstring =   $dirstring . "-$row[5]"; } #4
	if ($row[6] ne "") { $row[6] = acs::encode_dir($row[6]); $dirstring =   $dirstring . "-$row[6]"; } #5
	if ($row[7] ne "") { $row[7] = acs::encode_dir($row[7]); $dirstring =   $dirstring . "-$row[7]"; } #6
	if ($row[8] ne "") { $row[8] = acs::encode_dir($row[8]); $dirstring =   $dirstring . "-$row[8]"; } #7
	if ($row[9] ne "") { $row[9] = acs::encode_dir($row[9]); $dirstring =   $dirstring . "-$row[9]"; } #8
	if ($row[10] ne ""){ $row[10] = acs::encode_dir($row[10]); $dirstring = $dirstring ."-$row[10]"; } #9
	
	if ($row[11] ne ""){ $row[10] = acs::encode_dir($row[11]); $dirstring = $dirstring ."-$row[11]"; } #10
	if ($row[12] ne ""){ $row[10] = acs::encode_dir($row[12]); $dirstring = $dirstring ."-$row[12]"; } #11
	if ($row[13] ne ""){ $row[10] = acs::encode_dir($row[13]); $dirstring = $dirstring ."-$row[13]"; } #12
	if ($row[14] ne ""){ $row[10] = acs::encode_dir($row[14]); $dirstring = $dirstring ."-$row[14]"; } #13
	if ($row[15] ne ""){ $row[10] = acs::encode_dir($row[15]); $dirstring = $dirstring ."-$row[15]"; } #14
	if ($row[16] ne ""){ $row[10] = acs::encode_dir($row[16]); $dirstring = $dirstring ."-$row[16]"; } #15
	if ($row[17] ne ""){ $row[10] = acs::encode_dir($row[17]); $dirstring = $dirstring ."-$row[17]"; } #16

	if ($row[20] eq "") { $row[20] = 0; }

	$locked_stat = "";
	if ($row[22] eq "Y") { $locked_stat = " <img src=\"$web_url/locked.gif\">"; }

	if ($last_dname eq "") { $last_dname = "Root "; }
	if ($smc == 0) 
		{
		$movedirs = $movedirs . " <img src=\"$web_url/dir.gif\"> <b>$last_dname</b> <br>";
		$selbox = "checked";
		}
		else
		{
		$selbox = "";
		}
	$smc++;
	
	$moveval = "$row[0]" . "___MVSPLT___" . "$row[28]";
	
	$movedirs = $movedirs . "<input type=\"radio\" name=\"movecat\" $selbox value=\"$dirstring\" onclick=\"get_search_form('$dirstring');\"\> <img src=\"$web_url/subdir.gif\"> <a href=\"$admin_url/p_specsearch.cgi?fct=cat_search_start&mlv=$mlv&mct=$dirstring&cid=$row[0]&ct=$ct&$selstring\">$row[28]</a></strong> ($row[20]) $locked_stat<br>";
	
	$oid = $row[0];
	}

$sth->finish;
$dbh->disconnect;



#### CURRENT MOVE LOCATION

if ($mct eq "")
	{
	$currentloc = "Root ";
	}
	else
	{
	$currentloc = "<a href=\"$admin_url/p_specsearch.cgi?fct=cat_search_start&mlv=&mct=&cid=$cid&rid=$rid&ct=$ct&fct=$fct&$selstring&opaction=$opaction&$newsub&linkchk=$linkchk\">Root</a> ";
	
	$n_mlv = 1;
	
	@allds = split (/-/, $mct);
	$ccnr = @allds;

	foreach $aitem (@allds)
		{
		$n_mct = $n_mct . $aitem . "-";
		
		$cdname = acs::decode_dir($aitem);
		
		$cnn_mct = substr($n_mct, 0, length($n_mct) - 1);
		
		if ($ccnr ne $n_mlv)
			{
			$currentloc = $currentloc . " > <a href=\"$admin_url/p_specsearch.cgi?fct=cat_search_start&mlv=$n_mlv&mct=$cnn_mct&cid=$cid&rid=$rid&ct=$ct&fct=$fct&$selstring&opaction=$opaction&$newsub&linkchk=$linkchk\">$cdname</a> ";
			}
			else
			{
			$currentloc = $currentloc . " > $cdname ";
			}
		
		$n_mlv++;
		}
	
	}

#### 

if ($dirstring !~ /-/)
	{
	$pmct = "";
	}
	else
	{
	$pmct = "$mct";
	}


#####

if ($mlv eq "")
	{
	$create_lv = 0;
	}
	else
	{
	$create_lv = $mlv -1;
	}

if ($rows == 0)
	{
$movedirs = <<END_OF_NONE;

<p><span class="normaltext"><strong>This category contains no sub
directories/categories. <br>
</strong></span><span class="normaltext">Use the back button of your
browser to go back.</span></p>

END_OF_NONE
	}
	elsif ($q->param('fct') eq "")
	{
		$movebut = "<input type=\"submit\" value=\"   Assign   \" name=\"movebutton\" style=\"font-family: MS Sans Serif; font-size: 8\" onclick=\"post_value();\">";
	}
	elsif ($q->param('fct') eq "related")
	{
	
		if ($q->param('linkchk') eq "true")
		{
		$movebut = "<input type=\"submit\" value=\"   Assign   \" name=\"movebutton\" style=\"font-family: MS Sans Serif; font-size: 8\" onclick=\"post_value3(); return false;\">";
		$linkchk = "true";
		}
		else
		{
		$movebut = "<input type=\"submit\" value=\"   Assign   \" name=\"movebutton\" style=\"font-family: MS Sans Serif; font-size: 8\" onclick=\"post_value2(); return false;\">";
		}
		
	}

###############


$gsettings = new_gsettings acs;

if ($gsettings->{searchmeth} eq "fulltext")
{
$searchsc = "search2.cgi";
}
else
{
$searchsc = "search.cgi";
}



print <<END_OF_MVL;

<html>
<head>
<title>Select a Category</title>

<script LANGUAGE="JavaScript">
<!-- Hide

  function get_search_form(passonv)
   {
		 asform.S1.value = '<form method=\"POST\" action=\"$script_url/$searchsc\"><input type=\"hidden\" name=\"cat_search\" value=\"CST_' + passonv + '\"><input type=\"text\" name=\"keywords\" size=\"31\" value><input type=\"submit\" value=\"Search\" name=\"Search\"></form>';
   }
   
// End Hide -->
</script>



</head>
<body>


<form method="POST" action="$movecgi" name="asform" >
  <input type="hidden" name="fct" value="$fct">
  <input type="hidden" name="ct" value="$ct">
  <input type="hidden" name="links_to_move" value="$hselstring">
  <input type="hidden" name="cid" value="$cid">
  <input type="hidden" name="rid" value="$rid">
  <input type="hidden" name="mct" value="$pmct">
  <input type="hidden" name="newsub" value="$newsub2">
  <input type="hidden" name="email" value="$newsubemail">
  <input type="hidden" name="lastid" value="$oid">
  

<span class="normaltext"><div align="center"><center>

<table border="0" cellpadding="6" cellspacing="0" width="100%">
  <tr>
    <td width="50%" valign="top">
    
    <span class="normaltext"><strong>Current Location: </strong><img src="$web_url/lar.gif" width="6" height="10"> <b>$currentloc</b></span><blockquote>
      <p><span class="normaltext">$movedirs</span></p>
    </blockquote>
    
    </td>
    <td width="50%" valign="top" style="border-left: 1px solid rgb(239,239,239)"><span class="normaltext"><strong>Category Search HTML Code:<br>
    </strong>When choosing a category on the righ, HTML code will be displayed in the box
    below that you can use to provide your visitors with specific category searches:</span>
    <form method="POST" action="$admin_url/admin.cgi">
      <p><span class="normaltext">
      
      <p align="center">
      <textarea rows="12" name="S1" cols="30" style="width:100%">$shtmlcode</textarea>
      </p>
      
      </span></p>
    </form>
    </td>
  </tr>
</table>
</center></div>

<p>&nbsp;</p>
</span>

</form>


</body>
</html>


END_OF_MVL



}





sub start2
{


$keydata = acs::get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

foreach $k_item (@akeys)
		{
		($keyname, $visible, $size, $searched, $description1, $na, $imgk) = split (/\t/, $k_item);

		$extra_key_boxes = $extra_key_boxes . qq[<input type="checkbox" name="$keyname" value="$keyname" checked>$keyname<BR>];
		}


$hbox = acs::get_heading_box("$web_url/ic_searchc1.gif", "Specialized Searches", qq[
This plugin allows you to create specialized searches that will only search fields you specify.<BR>
<b><a href="$admin_url/p_specsearch.cgi">Go Back</a></b>
]);

print qq[
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>

<body>

$hbox


<form method="POST" action="$admin_url/p_specsearch.cgi">
  <input type="hidden" name="fct" value="get_search_form"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#DADADA">
    <tr>
      <td width="100%" height="30" colspan="2" background="$web_url/bar6.gif" bgcolor="#FFFFFF" class="normaltext"><strong>Choose
      Options: </strong></td>
    </tr>
    <tr>
      <td width="39%" height="30" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Choose fields to be
      included in this search: </strong></td>
      <td width="61%" height="30" valign="top" bgcolor="#FFFFFF" class="normaltext"><input type="checkbox"
      name="title" value="title" checked> Title <br>
      <input type="checkbox" name="diz" value="description" checked> Description <br>
      <input type="checkbox" name="kw" value="keywords" checked> Keywords <br>
      <input type="checkbox" name="url" value="url" checked> URL <br>
      <strong>$extra_key_boxes </strong></td>
    </tr>
    <tr>
      <td width="39%" valign="top" bgcolor="#FFFFFF" class="normaltext"><strong>Choose the matching method: </strong></td>
      <td width="61%" valign="top" bgcolor="#FFFFFF" class="normaltext"><input type="radio" CHECKED
      value="internal" name="mtype"> Determine the best matches. <br>
      <input type="radio" value="andkeywords" name="mtype"> All the keywords supplied must match
      inside any field of a link <br>
      <input type="radio" value="phrase" name="mtype"> Search with the exact phrase. (The phrase
      must match to find a match) </td>
    </tr>
    <tr>
      <td width="39%" height="30" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="61%" height="30" bgcolor="#FFFFFF" class="normaltext"><input type="submit" value="Submit"
      name="B1"> <p>You will be given HTML code after pressing the 'Submit' button. You can then
      copy and paste this into any web page or PowerSeek template to provide the search you
      configured here to your visitors. </td>
    </tr>
  </table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>
</form>


</body>
</html>
];

}



sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

